love.graphics.setDefaultFilter( 'nearest', 'nearest' )
require 'player/player'

function love.load()
	min_dt = 1/125
	next_time = love.timer.getTime()

	tile_size = 24
	x = 0
	y = 0

	player = Player:new()

	i_left  = "a"
	i_right = "d"
	i_up    = "w"
	i_down  = "s"
	i_jump  = "r"
	jump_pressed = false

	love.graphics.setBackgroundColor( 114, 156, 52 )

	slopes = love.graphics.newImage("maps/slopes.png")
	slope_1 = love.graphics.newQuad(0, 0, tile_size, tile_size, slopes:getDimensions())
	slope_2 = love.graphics.newQuad(tile_size, 0, tile_size, tile_size, slopes:getDimensions())
	slope_3 = love.graphics.newQuad(tile_size*2, 0, tile_size, tile_size, slopes:getDimensions())
end

function love.update(dt)
	next_time = next_time + min_dt

	--rest of function here
	player:update(min_dt)
end

--[[

 MAPA 53x30

]]

map = {}

map_width = 53
map_height = 30

for i=1, map_width, 1 do
	map[i] = {}
	for j=1, map_height, 1 do
		map[i][j] = {['type'] = 0}
	end
end
--trash--trash--trash--trash--trash--trash--trash--trash--trash--trash--trash

for i=1, map_width, 1 do
	for j=28, 30, 1 do
		map[i][j] = {['type'] = 1}
	end
end

for i=5, 15, 1 do
	for j=26, 28, 1 do
		map[i][j] = {['type'] = 1}
	end
end

map[1][1] = {['type'] = 1}
map[2][1] = {['type'] = 1}
map[13][24] = {['type'] = 1}
map[16][27] = {['type'] = 1}
map[17][27] = {['type'] = 2, ['section'] = 1, ['d'] = 'l' ,['r'] = 0, ['h'] =  1, ['v'] =  1, ['l_edge'] = 24, ['r_edge'] = 1}
map[16][26] = {['type'] = 2, ['section'] = 1, ['d'] = 'l' ,['r'] = 0, ['h'] =  1, ['v'] =  1, ['l_edge'] = 24, ['r_edge'] = 1}
map[15][25] = {['type'] = 2, ['section'] = 1, ['d'] = 'l' ,['r'] = 0, ['h'] =  1, ['v'] =  1, ['l_edge'] = 24, ['r_edge'] = 1}
--map[21][27] = {['type'] = 2, ['section'] = 2, ['d'] = 'l' ,['r'] = 90, ['h'] =  1, ['v'] =  -1, ['l_edge'] = 48, ['r_edge'] = 1}
--map[21][26] = {['type'] = 2, ['section'] = 3, ['d'] = 'l' ,['r'] = 90, ['h'] = 1, ['v'] = -1, ['l_edge'] = 24, ['r_edge'] = -24}
--map[20][27] = {['type'] = 1}
--map[20][26] = {['type'] = 1}
--map[20][25] = {['type'] = 2, ['section'] = 1, ['d'] = 'l' ,['r'] = 0, ['h'] =  1, ['v'] =  1, ['l_edge'] = 24, ['r_edge'] = 1}

--map[27][27] = {['type'] = 2, ['section'] = 1, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = 1, ['r_edge'] = 24}
--map[28][26] = {['type'] = 2, ['section'] = 1, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = 1, ['r_edge'] = 24}
--map[28][27] = {['type'] = 1}
--map[29][25] = {['type'] = 2, ['section'] = 2, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = 1, ['r_edge'] = 48}
--map[29][24] = {['type'] = 2, ['section'] = 3, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = -24, ['r_edge'] = 24}
--map[29][26] = {['type'] = 1}

-- new test
-- Left Slope / 3 / Podstawa
map[41][27] = {['type'] = 2, ['section'] = 2, ['d'] = 'l' ,['r'] = 90, ['h'] =  1, ['v'] =  -1, ['l_edge'] = 48, ['r_edge'] = 1}
-- Left Slope / 3 / Góra
map[41][26] = {['type'] = 2, ['section'] = 3, ['d'] = 'l' ,['r'] = 90, ['h'] = 1, ['v'] = -1, ['l_edge'] = 24, ['r_edge'] = -24}

map[40][27] = {['type'] = 1}
map[40][26] = {['type'] = 1}
-- Left Slope / 2 /
map[40][25] = {['type'] = 2, ['section'] = 1, ['d'] = 'l', ['r'] = 0, ['h'] = 1, ['v'] = 1, ['l_edge'] = 24, ['r_edge'] = 1}

map[39][25] = {['type'] = 1}
-- Left Slope / 1 / Podstawa
map[39][24] = {['type'] = 2, ['section'] = 3, ['d'] = 'l', ['r'] = 0, ['h'] = 1, ['v'] = 1, ['l_edge'] = 12, ['r_edge'] = 1}

map[38][25] = {['type'] = 1}

-- Left Slope / 1 / Góra
map[38][24] = {['type'] = 2, ['section'] = 2, ['d'] = 'l', ['r'] = 0, ['h'] = 1, ['v'] = 1, ['l_edge'] = 24, ['r_edge'] = 12}
map[37][24] = {['type'] = 1}
map[36][24] = {['type'] = 2, ['section'] = 2, ['d'] = 'r', ['r'] = 180, ['h'] = -1, ['v'] = 1, ['l_edge'] = 12, ['r_edge'] = 24}
map[35][24] = {['type'] = 2, ['section'] = 3, ['d'] = 'r', ['r'] = 180, ['h'] = -1, ['v'] = 1, ['l_edge'] = 1, ['r_edge'] = 12}
map[34][25] = {['type'] = 2, ['section'] = 1, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = 1, ['r_edge'] = 24}
map[37][25] = {['type'] = 1}
map[36][25] = {['type'] = 1}
map[35][25] = {['type'] = 1}
map[33][27] = {['type'] = 2, ['section'] = 2, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = 1, ['r_edge'] = 48}
map[33][26] = {['type'] = 2, ['section'] = 3, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = -24, ['r_edge'] = 24}
map[34][26] = {['type'] = 1}
map[34][27] = {['type'] = 1}
map[32][28] = {['type'] = 2, ['section'] = 1, ['d'] = 'r' ,['r'] = -90, ['h'] =  1, ['v'] =  1, ['l_edge'] = 1, ['r_edge'] = 24}
map[31][28] = {['type'] = 0}
map[28][26] = {['type'] = 1}


--map[20][24] = {['type'] = 1}
--map[21][23] = {['type'] = 1}
--map[21][24] = {['type'] = 3, ['section'] = 1, ['d'] = 'tl' ,['r'] = -90, ['h'] = -1, ['v'] = -1, ['l_edge'] = 24, ['r_edge'] = 1}
--map[22][23] = {['type'] = 3, ['section'] = 1, ['d'] = 'tl' ,['r'] = -90, ['h'] = -1, ['v'] = -1, ['l_edge'] = 24, ['r_edge'] = 1}
-- d=direction		r=rotation		h=horizontal	v=vertical
--map[16][27] = {['type'] = 0}

--trash--trash--trash--trash--trash--trash--trash--trash--trash--trash--trash
current_map = map

function collision(type, x, y)
	local tile_x = math.ceil(x / tile_size)
	local tile_y = math.ceil(y / tile_size)

	local tile = current_map[tile_x][tile_y]
	if tile['type'] == type then
		return true
	else
		return false
	end
end

function get_tile(x, y)
	local tile_x = math.ceil(x / tile_size)
	local tile_y = math.ceil(y / tile_size)

	local tile = current_map[tile_x][tile_y]
	tile['x'] = tile_x
	tile['y'] = tile_y
	return tile
end

function draw_map()
	for i=1, 53, 1 do
		for j=1, 30, 1 do
			if map[i][j]['type'] == 1 then
				love.graphics.setColor( 28, 48, 0 )
				love.graphics.rectangle("fill", (i*24)-24, (j*24)-24, 24, 24)
				love.graphics.setColor( 255, 255, 255 )
			end
			if (map[i][j]['type'] == 2 or map[i][j]['type'] == 3) and map[i][j]['section'] == 1 then
				love.graphics.draw(slopes, slope_1, (i*tile_size) - (tile_size / 2), (j*tile_size) - (tile_size / 2), math.rad(map[i][j]['r']), map[i][j]['v'], map[i][j]['h'], math.floor(tile_size / 2), math.floor(tile_size / 2))
			end
			if (map[i][j]['type'] == 2 or map[i][j]['type'] == 3) and map[i][j]['section'] == 2 then
				love.graphics.draw(slopes, slope_2, (i*tile_size) - (tile_size / 2), (j*tile_size) - (tile_size / 2), math.rad(map[i][j]['r']), map[i][j]['v'], map[i][j]['h'], math.floor(tile_size / 2), math.floor(tile_size / 2))
			end
			if (map[i][j]['type'] == 2 or map[i][j]['type'] == 3) and map[i][j]['section'] == 3 then
				love.graphics.draw(slopes, slope_3, (i*tile_size) - (tile_size / 2), (j*tile_size) - (tile_size / 2), math.rad(map[i][j]['r']), map[i][j]['v'], map[i][j]['h'], math.floor(tile_size / 2), math.floor(tile_size / 2))
			end
		end
	end
end

function love.draw()
	draw_map()
	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	player:draw()
	--rest of function here

	local cur_time = love.timer.getTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	love.timer.sleep(next_time - cur_time)
end

function love.keyreleased(key)
	-- if you release run button on the floor
	if (key == i_right or key == i_left) and player.on_floor then
		player.run_timer = 0
	end

	--if key == "2" then player.x_vel = player.x_vel + 500 end
	--if key == "1" then player.x_vel = player.x_vel - 500 end
	if key == "2" then player.x = player.x + 200 end
	if key == "1" then player.x = player.x - 200 end
	if key == "3" then player.x = player.x - 1 end
	if key == "4" then player.x = player.x + 1 end
	--if key == "3" then player.x_vel = player.x_vel - 17 end
	--if key == "4" then player.x_vel = player.x_vel + 17 end
	if key == "5" then player.y = player.y + 1 end
	if key == "6" then player.y = player.y - 1 end
	if key == "7" then player.gravity = 0 end
	if key == "o" then file:open('a') end
end

function math.round(x)
	return math.floor(x + 0.5)
end

function deepcopy(orig)
	local orig_type = type(orig)
	local copy
	if orig_type == 'table' then
		copy = {}
		for orig_key, orig_value in next, orig, nil do
			copy[deepcopy(orig_key)] = deepcopy(orig_value)
		end
		--setmetatable(copy, deepcopy(getmetatable(orig)))
	else -- number, string, boolean, etc
		copy = orig
	end
	return copy
end